unit Unit1;

{ floodfill exerciser
  feb. 2015
  version 1
  dec. 2021
  version 1.1
  corrected error:  Xcliprect not initialized prevents painting on bitmaps
  in Delphi 10,11 versions
}  

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, dav7components, ExtCtrls, StdCtrls,unit3,shellApi;

type
  TForm1 = class(TForm)
    colorpicker: Tdav7ColorPicker;
    widthBtn: TDavArrayBtn;
    fillselector: TDavArrayBtn;
    menuBtn: TDavArrayBtn;
    clearBtn: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    PaintBox1: TPaintBox;
    msgtext: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Image1: TImage;
    Image2: TImage;
    PaintBox2: TPaintBox;
    Image3: TImage;
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure menuBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure menuBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure colorpickerSelect(sender: TObject; color: Integer);
    procedure widthBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure fillselectorBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure fillselectorBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure PaintBox2Paint(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure widthBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure clearBtnClick(Sender: TObject);
    procedure Image3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TmenuButton = (mbLine,mbEllipse,mbRect,mbFree,mbFill,mbOff);

var
  Form1: TForm1;
  map1,map2 : TXBitmap;
  menuButton : TmenuButton = mbOff;
  pencolor : dword;
  fillpattern : byte = 0;
  penwidth : byte = 1;

implementation

{$R *.dfm}

uses unit2;

var fillmap : TXbitmap;

procedure paintedge(ct : TControl);
var x1,y1,x2,y2 : word;
    i : byte;
  par : TCustomform;
begin
 with ct do
  begin
   x1 := left-2;
   y1 := top - 2;
   x2 := left + width + 1;
   y2 := top + height + 1;
  end;
 par := getparentform(ct);
 with par do with canvas do
  begin
   pen.Width := 1;
   pen.style := psSolid;
   for i := 0 to 1 do
    begin
    pen.color := $000000;
    moveto(x2-i,y1+i);
    lineto(x1+i,y1+i);
    lineto(x1+i,y2-i);
    pen.color := $808080;
    lineto(x2-i,y2-i);
    lineto(x2-i,y1+i);
   end;
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintedge(paintbox1);
 paintedge(paintbox2);
end;

procedure initmap1;
var i : word;
begin
 with map1 do with canvas do
  begin
   brush.color := $e3ffff;           //level 3
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   i := 20;
   xpenlevel := 3;
   xpencolor := $ffe0e0;
   xpenwidth := 1;
   while i < width do
    begin
     xline(i,0,i,height-1);
     inc(i,40);
    end;
    i := 0;
    xpencolor := $ffc0c0;
    while i < width do
    begin
     xline(i,0,i,height-1);
     inc(i,40);
    end;
   i := 20;
   xpencolor := $ffe0e0;
   while i < height do
    begin
     xline(0,i,width-1,i);
     inc(i,40);
    end;
   i := 0;
   xpencolor := $ffc0c0;
   while i < height do
    begin
     xline(0,i,width-1,i);
     inc(i,40);
    end;
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 showmap1;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 map1 := TXBitmap.create;
 with map1 do
  begin
   width := paintbox1.Width;
   height := paintbox1.height;
   XCliprect := rect(0,0,width,height); //v1.1 ==
  end;
 map2 := TXBitmap.create;
 with map2 do
  begin
   width := paintbox1.Width;
   height := paintbox1.height;
   XCliprect := rect(0,0,width,height);//v1.1 ==
  end;
 initmap1;
 fillmap := TXBitmap.create;
 with fillmap do
  begin
   width := 32;
   height := 24;
   XCliprect := rect(0,0,width,height);//v1.1 ==
  end;
 widthbtn.btnDown(0);
 fillselector.BtnDown(0);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 map1.free;
 map2.Free;
 fillmap.Free;
end;

procedure TForm1.menuBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
var r : Trect;
begin
 with menuBtn do with canvas do
  begin
   r := getBtnrect(BtnNr);
   case TmenuButton(BtnNr) of
    mbLine    : begin
                 pen.Width := 2;
                 pen.color := $0;
                 moveto(r.Left+4,r.bottom - 4);
                 lineto(r.Right -4,r.Top +  4);
                end;
    mbEllipse : begin
                 pen.Width := 2;
                 pen.color := $0;
                 ellipse(r.Left+4,r.Top+4,r.Right-4,r.Bottom-4);
                end;
    mbFree    : begin
                 draw(r.Left,r.Top,image1.Picture.Bitmap);
                end;
    mbFill    : begin
                  draw(r.Left,r.Top,image2.Picture.Bitmap);
                end;
    mbRect    : begin
                 pen.color := $0;
                 pen.Width := 2;
                 roundrect(r.Left+5,r.Top+5,R.right-5,r.Bottom-5,10,10);
                end;
   end;//case
  end;
end;

procedure TForm1.menuBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 msgtext.caption := '';
 menuButton := mbOff;
 if status = stDown then
  begin
   menubutton := TMenubutton(BtnNr);
   case menubutton of
    mbLine    : msgtext.caption := 'paint lines';
    mbEllipse : msgText.Caption := 'paint ellipses';
    mbFree    : msgtext.Caption := 'freehand drawing';
    mbFill    : msgtext.Caption := 'fill area';
    mbRect    : msgText.Caption := 'paint rectangle';
   end;
  end; 
end;

procedure TForm1.colorpickerSelect(sender: TObject; color: Integer);
begin
 pencolor := color;
 paintbox2.invalidate;
end;

procedure TForm1.widthBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
var r : Trect;
    i : byte;
begin
 with widthBtn do with canvas do
  begin
   r := getBtnrect(BtnNr);
   pen.color := $0;
   pen.Width := 1;
   for i := 0 to btnNr do
    begin
     moveto(r.Left + 4,r.Top+20+i);
     lineto(r.Right-4,r.Top+20+i);
    end;
  end;
end;

procedure TForm1.fillselectorBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
var r : Trect;
begin
 with fillmap do with canvas do
  begin
   canvas.Brush.Color := $c3c3c3;
   fillrect(rect(0,0,width,height));
   xusebrush := true;
   xpenlevel := 0;
   xpenwidth := 1;
   xbrushlevel := 2;
   xfillsize := fms8;
   xfillstyle := btnNr;
   xbrushcolor := $0;
   xfloodfill(10,10);
  end;
 with fillselector do with canvas do
  begin
   r := getBtnRect(BtnNr);
   draw(r.Left+4,r.Top+4,fillmap);
  end;
end;

procedure TForm1.fillselectorBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 fillpattern := btnNr;
end;

procedure TForm1.widthBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 penwidth := BtnNr + 1;
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
begin
 with paintbox2 do with canvas do
  begin
   brush.Color := pencolor;
   fillrect(rect(0,0,width,height));
  end;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mouseproc(maDown,x,y);
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 mouseproc(maMove,x,y);
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mouseProc(maUP,x,y);
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 initmap1;
 showmap1;
end;

procedure TForm1.Image3Click(Sender: TObject);
//davdata
begin
 ShellExecute(0,'open','http://www.davdata.nl/math', nil, nil, SW_SHOWNORMAL);
end;

end.
